<?php
declare(strict_types=1);

namespace IntiTest\Db;

use Laminas\ConfigAggregator\ArrayProvider;
use Laminas\ConfigAggregator\ConfigAggregator;
use Laminas\ServiceManager\ServiceManager;
use PHPUnit\Framework\TestCase;
use Psr\Container\ContainerInterface;

/**
 * Class AbstractTestCase
 *
 * @package IntiTest\Db\Connection
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-db
 */
abstract class AbstractTestCase extends TestCase
{
    protected function getContainer(array $config = []): ContainerInterface
    {
        $config = (new ConfigAggregator([
            \Inti\Db\ConfigProvider::class,
            ConfigProvider::class,
            new ArrayProvider($config),
        ]))->getMergedConfig();

        $config['dependencies']['services']['config'] = $config;
        return new ServiceManager($config['dependencies']);
    }
}
